;----------------------------------------------------------------------------
; PC-9821 PCI@p Software DIPXCb`2-2ύX V2.01  (C) 2021/11/07 DOSsoft
;----------------------------------------------------------------------------
.186    ; 

;IPLWARE equ 1

code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
main:
                call    CheckEnv
                jc      ProgramAborted

ifdef   IPLWARE 
                call    BasSW22
;;              call    TrmSW22
else
                call    Flip_BAS_TRM  
endif
ProgramAborted: 
                RET             ; ŏI
CurrentSetting  DB      0

;Ql
; code 7601 line 01  SW2-2
; bit0  s
; bit1  0=terminal mode , 1=BASIC mode
; bit2  s(80/40s)
; bit3  0=25 lines ,      1=20lines 
; bit4  0=GDC 2.5MHz,     1=GDC 5MHz
; bit5  0=InHDD disable,  1=enable 
; bit6  s
; bit7  Odd peB
;IPLWARE 

CheckEnv        PROC   near
                xor     ax,ax
                mov     es,ax
                mov     ax,0F8E8h
                test    byte ptr es:[0501h],8
                jz      @f
                mov     ax,0FFE8h       ; hireso mode
        @@:     mov     bx,es           ; bx=0000
                mov     es,ax
                mov     ax,es:[bx]      ; bx=0000
                cmp     ax,2198h        ; 9821 check
                jne     EnvNG           ; NE fail
                mov     al,es:[0004h]   ; K.Takata's investigation
                test    al,00100000b    ; bit5 1=PCI oXڃtO
                jz      EnvNG           ; NZ fail
EnvOK:          clc
                ret
EnvNG:          
ifNdef   IPLWARE 
                mov     dx,offset msg_ERR
                call    _puts
endif
                stc
                ret
CheckEnv        ENDP

;--------------------------------------------------------
;       ActivateSDIPSW        input AH,CX,DX
;       DX=char code by JIS , CX= line NO. , al=value
;--------------------------------------------------------
ActivateSDIPSW  PROC   near
                pushf
                cli
                mov     al,cl   ; 
                shr     al,04h  ; 
                add     al,dl   ;
                out     0A1h,al
                mov     al,dh
                and     al,7Fh
                out     0A3h,al
                mov     al,dh
                and     al,80h
                shr     al,02h
                and     cl,0Fh
                add     al,cl
                out     0A5h,al
                out     5Fh,al
                out     5Fh,al
                in      al,0A9h
                popf
                ret 
ActivateSDIPSW  ENDP

;-------------------------------------------------------
;       Enable/Disable SerialROM    input CX 0=dis 1=en
;-------------------------------------------------------
SetSerialROM    PROC   near
                push    dx
                mov     dx,18F0h
                mov     ax,0017h
                out     dx,ax           ; by WORD 
                out     5Fh,al
                out     5Fh,al
                mov     dx,18F2h
                mov     AX,CX
                out     dx,ax           ; by WORD 
                out     5Fh,al
                out     5Fh,al
                pop     dx
                ret
SetSerialROM    ENDP
;----------------------------------------------
EnableSerialROM PROC   near
                push    cx
                push    ax
                mov     al, 0Bh         ; to dot access mode
                out     068h, al
                mov     cx,1
                call    SetSerialROM
                pop     ax
                pop     cx
                ret
EnableSerialROM ENDP
;----------------------------------------------
DisableSerialROM   PROC   near
                push    cx
                push    ax
                mov     cx,0
                call    SetSerialROM
                mov     al, 0Ah         ; to code access mode
                out     068h, al
                pop     ax
                pop     cx
                ret
DisableSerialROM   ENDP
;----------------------------------------------


ifdef   IPLWARE 

;-------------------------------------------------------------
;     BAS/[TRM]  ݒL PCI@SʁHiԂ񏉑XaȂǏj
;-------------------------------------------------------------
TrmSW22         PROC   near
                call    EnableSerialROM
                mov     dx,5601h        ; code 7601h
                mov     cl,01h          ; cl=01h ̂悤ł
                call    ActivateSDIPSW  ; ̒lǂݏo
                mov     ah,11111101b    ; bit1  1=Terminal mode, 0=BASIC mode
                and     al,ah
                and     al,7Fh          ; reset parity bit7
                jnp     @f
                or      al,80h          ; odd parity bit 7
        @@:     nop
                out     0A9h,al
                call    DisableSerialROM
                ret
TrmSW22         ENDP


;-------------------------------------------------------------
;     [BAS]/TRM  ݒL PCI@SʁHiԂ񏉑XaȂǏj
;-------------------------------------------------------------
BasSW22         PROC   near
                call    EnableSerialROM
                mov     dx,5601h        ; code 7601h
                mov     cl,01h          ; cl=01h
                call    ActivateSDIPSW  ; ̒lǂݏo
                mov     ah,00000010b    ; bit1  1=Terminal mode, 0=BASIC mode
                or      al,ah
                and     al,7Fh          ; reset parity bit7
                jnp     @f
                or      al,80h          ; odd parity bit 7
        @@:     
                out     0A9h,al
                call    DisableSerialROM
                ret
BasSW22         ENDP

else
;------------------------------------------------
;     Flip mode
;------------------------------------------------
Flip_BAS_TRM  PROC   near
                call    EnableSerialROM
                xor     ax,ax
                mov     dx,5601h
                mov     cl,01h
                call    ActivateSDIPSW  ; ̒lǂݏo
                mov     cs:CurrentSetting,al
                test    al,00000010b    ;
                jz      AlreadyTRMmode
AlreadyBASmode: and     al,11111101b    ; bitl ւ
                jmp     @f
AlreadyTRMmode: or      al,00000010b    ; bit 1=1
        @@:     
                and     al,7Fh          ; reset parity bit7
                jnp     OddParity
                or      al,80h          ; odd parity bit 7
    OddParity:  out     0A9h,al         ; 
                mov     cs:CurrentSetting,al
                call    DisableSerialROM

                mov     dx,offset msg_mode_is
                call    _puts

                mov     al,cs:CurrentSetting
                mov     dx,offset msg_BAS
                test    al,00000010b
                jnz     @f
                mov     dx,offset msg_TRM
        @@:     call    _puts
                ret
Flip_BAS_TRM  ENDP

;-----------------------------------------------------------------
;       puts for MS-DOS
;-----------------------------------------------------------------
_puts           PROC    near
                pusha
;                inc     dx
                mov     bx,dx
_puts_ent:       cmp     byte ptr [bx],0
                jz      ext
                inc     bx
                jmp     _puts_ent
ext:            mov     byte ptr [bx],'$'
                mov     ah,9
                int 21h
                mov     byte ptr [bx],0
                sub     bx,dx           ;\Ԃ
                mov     ax,bx
                popa
                ret
_puts            ENDP

msg_mode_is     DB "4.3GB CF CHSݒ",0;
msg_TRM         DB " ulCeBuvɕύX܂. ",13,10
                DB "iDIP SW2-2  , ROM BASICӰށj",13,10,0
msg_BAS         DB " IDE HDD݊i8:17jɕύX܂.  ܂.",13,10
                DB "iDIP SW2-2  , ROM BASICʏӰށj",13,10,0
msg_ERR         DB "̃vO DIP SW2-2 ύX邱Ƃ͂ł܂. ",13,10
                DB "n[hEFADIPXCb`܂̓VXeZbgAbvj[𑀍삵Ă. ",13,10,0
endif

code    ends
        end     main
