ExtendedCode    label   byte
BIOS_ParamTable label   word    ;  EXIDEM9[hftHg
                DW      0811h  ; < 4351MB 
                DW      103Fh  ; < 8192MB
                DW      103Fh  ; < 32255MB
                DW      10FFh  ; < 32768MB
                DW      10FFh  ; < 61GB
                DW      10FFh  ; < 64GB
                DW      10FFh  ; < 122GB
                DW      10FFh  ; < above 128GB
ModeFlagFixed   DB      00h     ; Copied from SOFTWARE SWITCH
CF_FlagFixed    DB      00h     ; Copied from SOFTWARE SWITCH

SelectCHS       PROC    near
                mov     ax,es:[di+78h]  ; LBA foCXlo
                xchg    al,ah           ; gGfBA
                mov     dx,es:[di+7Ah]  ; LBA foCXlo
                xchg    dl,dh           ; gGfBA
                ror     eax,16
                mov     ax,dx
                rol     eax,16          ; DX:AX => EAX
if 0
                or      eax,eax
                jnz     SupportLBA
; LBA==0
                mov     ax,es:[di+0Ch]  ; sectN
                xchg    al,ah
                mov     cx,es:[di+06h]  ; headN
                xchg    cl,ch
                mul     cl
                mov     cx,es:[di+02h]  ; cylnN
                xchg    cl,ch
                mul     cx
                ror     eax,16
                mov     ax,dx
                rol     eax,16
endif
SupportLBA:     

ifdef   CF_NATIVE
                call    CheckCF ;2020-12-7  CFǂ 2024-3-1
                jc      DeviceCFA
endif
                mov     si,offset BIOS_ParamTable

                cmp     eax,00880000h ; 4351.9MB
                jb      CapaOK1       ; 
                inc     si
                inc     si

; replace location 2019.10.16
                cmp     byte ptr cs:ModeFlagFixed, 0
                je      Original8063Mode
                cmp     byte ptr cs:ModeFlagFixed, MODE_4G_COMPATI
                je      Param_4G_COMPATI

                cmp     eax,01000000h ; 8G
                jb      CapaOK2
                inc     si
                inc     si
;;;             jmp     NotOriginal8063Mode
Original8063Mode:
                cmp     eax,03EFFC10h; 31.5G
                jb      Param315
NotOriginal8063Mode:
                cmp     eax,03EFFC10h; 31.5G
                jb      ParamSet
                inc     si
                inc     si
                cmp     eax,04000000h ; 32G
                jb      ParamSet
; 32GBȏ
                cmp     byte ptr cs:ModeFlagFixed, MODE_ORTHO_SCSI ;(=2)
                je      ortho_scsi_mode ; ̃[hł͂őł~
                inc     si
                inc     si
                cmp     eax,07800000h ; 61440MB
                jb      ParamSet
; 61.44GBȏ
                inc     si
                inc     si
                cmp     eax,08000000h; 65536MB
                jb      ParamSet
; 64GBȏ
                cmp     byte ptr cs:ModeFlagFixed, MODE_SSD_SCSI ;(=4)
                je      ssd_scsi_mode   ; ̃[hł͂őł~
                inc     si
                inc     si
; 120GBȏ
                cmp     eax,0EF10000h; 122.4GB
                jb      ParamSet
                cmp     byte ptr cs:ModeFlagFixed, MODE_MEL_SCSI ; (=3)
                je      ext_scsi_mode   ; ̃[hł͂őł~
;;;;;;;;;;;;    inc     si
;;;;;;;;;;;;    inc     si
; 16*255*65535 limit
                    mov     dx, 0FEFh
                    mov     ax,0F010h
CapaOK2:        
CapaOK1:
ParamSet:
                mov     cx,cs:[si]
ParamOK:        
                and     eax,0000FFFFh   ; 16bit̂Ă
                ret

ortho_scsi_mode:
                mov     dx,03FFh    ; Overflow΍, LBAlimit
                mov     ax,0FFFFh   ;   LBA max=0400000h
                jmp     ParamSet
ext_scsi_mode:  
                mov     dx, 0EF0h
                mov     ax,0FFFFh
                jmp     ParamSet
ssd_scsi_mode:  
                mov     dx, 07FFh
                mov     ax,0FFFFh
                jmp     ParamSet
ParamOK6:       
                jmp     ParamOK

Param315:       mov     cx,cs:[si]      ; CL=BIOS Sector, CH=BIOS head N
                cmp     byte ptr es:[di+06h+ 1],15 ; foCX HEAD==15 ?
                jne     Not15Heads
                cmp     dx,03B1h        ; 15*63*65535l
                jae     Not15Heads      ; ȏȂ15headɂłȂ
                mov     ch,15
Not15Heads:     jmp     ParamOK

Param_4G_COMPATI:
                mov     cx,cs:[si]      ; CL=BIOS Sector, CH=BIOS head N
                cmp     byte ptr es:[di+06h+ 1],15 ; foCX HEAD==15 ?
                jne     Not15Heads__
                mov     ch,15
                cmp     eax,03B0FFFFh
                jb      ParamOK
                mov     dx,03B0h
                mov     ax,0FFFFh
                jmp     ParamOK

ifdef   CF_NATIVE
DeviceCFA:      mov     ch,es:[di+06h+1] ; NATIVE foCX HEAD
                mov     cl,es:[di+0Ch+1] ; NATIVE foCX SECTOR
                cmp     cx,0
                jz      CF_CapaNG
                mov     dx,es:[di+7Ah]   ; LBAʃ[hwork areao
                xchg    dl,dh           ; gGfBA
                mov     ax,es:[di+78h]   ; LBAʃ[h
                xchg    al,ah           ; gGfBA
                cmp     eax,03EFFC10h; 31.5GB
                jb      CF_CapaOK
;                mov     al,06h          ; 32255MiB over̂ƂbeepiȂj
;                out     37h,al
                call    CF_CAPA_SHRINK  ; 2021-6-11 CF32255MBɏk
CF_CapaNG:      mov     cx,103Fh
                mov     dx,03EFh
CF_CAPA_SHRINK: mov     ax,0FC00h       ; 2021-6-11
CF_CapaOK:      jmp     ParamOK
endif

Not15Heads__:
                cmp     eax,03EFFFFFh
                jb      ParamOK
                mov     dx,03EFh
                mov     ax,0FFFFh
                jmp     ParamOK
SelectCHS       ENDP



NEWCODE_SET_CHS label   byte    ; Do not change ES and BX value
                push    ds
                push    bx      ; ES,BX,SI,DI ͕ۑ
                push    si
                push    cs      ; ds<=CS
                pop     ds

                call    SelectCHS       ; DX:AX=LBA   CX=H:S

                mov     bl,[bp+00]      ; drive number BX͂ŎQƂ
                and     bx,0003h        ; bh=0  
                shl     bx,5
                add     bx,2100h        ; get the addr of work area
                mov     SECT_2100,cl    ; 
                mov     HEAD_2100,ch    ; 

                 push    ax
                 mov     ah,00h
                 mov     al,ch          ; al= wbh         ; 63<S 
                 mul     cl             ;  cl=Head,  ax=H*S
                 mov     HS_2100,ax     ; ax=H*S
                 mov     cx,ax          ; cx=H*S
                 pop     ax

                div     cx              ; DX:AX / CX  V_
                mov     CYLN_2100,ax    ; cylinder count
                pop     si
                pop     bx              ; AXɃV_ACXH*SĕԂ
                pop     ds
                RETF

Ra300_SetCHS    label   byte
                push    bx              ; BX,SI,DI ͕ۑ
                push    si
                call    SelectCHS   ; DX:AX=LBA, CH=wbh, CL=ZN^ Ԃ
                pop     si
                pop     bx
                RETF
Ra300_SetCHS_E  label   byte

;2024-3-3
ifdef   CF_NATIVE
CheckCF         PROC   near
; identify̌ʂ
                mov     al,es:[di+00ACh+1]  ; word 87
                test    al,00000100b  ; CFA bit2 =1 Ȃ犮SCF
                jz      PostSetFeature66        ; 0= not CFA
DeviceMaybeCFA:                                         ; identified data area
                or      byte ptr es:[di+62h],00001000b  ; word 49 bit 11 IOREADY
                or      byte ptr es:[di+6Bh],00000010b  ; word 53 bit 1
                or      byte ptr es:[di+81h],00000001b  ; word 64 bit 0
                ; ȏύX邱ƂɂPIO3
                call    Set66h
                call    CheckDIP22
                ret
PostSetFeature66:
                clc
                ret
CheckCF         ENDP

CheckDIP22      PROC   near
                push    ax
                in      al,31h  ; DIP SW2-2 
                test    al,00000010b    ; 1=BASIC[h  0=^[~i[h
                pop     ax
                jnz     @f
                cmp     eax,00880000h
                jae     @f
                stc     ; 4351MB  and ^[~i[h
                ret
        @@:     clc     ; 4351MB over  or BASIC[h
                ret
CheckDIP22      ENDP

Set66h          PROC   near
                push    cx
                push    dx
                push    ax
 
                mov	dx,0642h        ;IDEreg_Feature
                mov	al,66h
                out	dx,al
                out	5Fh,al
                ;  added in V3.51
                mov     al,[bp+00]      ; drive number ͂ŎQƂ
                and     al,00000001b    ; 
                shl     al,4            ; 
                or      al,0A0h         ; 98CHS.....
                mov	dx,064Ch        ;IDEreg_SDHead
                out	dx,al
                out	5Fh,al

                mov	cx,3333h
AtaCmdLoop1:
                out	5Fh,al
                out	5Fh,al
                mov	dx,064Eh        ;IDEreg_Status
                in	al,dx
                cmp	al,50h
                je	@f
                loop	AtaCmdLoop1
        @@:
                mov	al,0EFh
                out	dx,al           ;IDEreg_Command
                mov	cx,3333h
        @@:
                out	5Fh,al
                out	5Fh,al
               loop     @b
                
                pop     ax
                pop     dx
                pop     cx
                ret
Set66h          ENDP
endif

;------------------------------------------------------------------------
ExtendedCode_end label   byte
;------------------------------------------------------------------------
;       IDE BIOS WORK GA̎g
;D800:[2000]2000h byte RAMĂ
;[2100]`"Ǝ"ɎgpĂi8GΉ@Ɠdlɂj
;2100 es:[BX   ]   (Word) BIOS cylinder
;2107 es:[BX+07]   (Byte) BIOS sector
;2108 es:[BX+08]   (Word) BIOS sector*head
;210A es:[BX+0A]   (Byte) BIOS head
; +20h    IDE1
; +40h    IDE2
; +60h    IDE3
; Data area for IDENTOFY command (desktop machines)
; IDE0 = 2200
; IDE1 = 2400
; IDE2 = 2600
; IDE3 = 2800

; Data area for IDENTOFY command (mobile/notebook machines)
; IDE0 = 2600 ?
; IDE1 = 2800 ?
; IDE2 = 2A00 ?
; IDE3 = 2C00 ?
