PCI_VENDOR      equ     8086h; 1095h;  102Bh ; 9004h ;  1113h  ; 10ECh ;  
PCI_DEVICE      equ     1229h; 3512h;  0519h ; 8178h ;  1211h  ; 8139h ;  
ROM_IMAGE_SIZE  equ     10h     ; 8KBytes sector size 10h=8KB
.186
;----------------------------------------------------------------------------
;       PCI_boot_ROM_loader.s  (C)2003,17,18 ܂(DOSsoft) Version 1.15
;----------------------------------------------------------------------------
code            segment
                assume cs:code,ds:code,cs:code,ss:code
                org    0h
.386
PCI_ROM_boot_program:
;------------------------------------------------
PCI_ROM_signat  DB      55h,0AAh
INIT_ROMsize    DB      ROM_IMAGE_SIZE     ; 16KBytes
AT1stBoot:      RETF    ; JMP     INIT_AT_entry   
                DB      0,0,""
                org    0Ch     ; JUMP table INIT0 for C-bus ROM 
                RETF           ; This entry never be called.
                DW      0
                org    0Fh     ; JUMP table INIT1 for C-bus ROM 
                RETF           ; This entry never be called.
                DW      0
                org    12h     ; JUMP table EXTND for C-bus ROM 
                RETF ; jmp     CbusCall_12h   
                org    15h
                RETF
                DW      0
;------------------------------------------------
                org    18h
PCIR_pointer    DW      offset PCIR_signat
                DW      0000h
PC98_jmptbl     DB      "PC98"          ; offset 1Ch
                org    20h
                JMP     INIT0_entry     ; offset 20h
                DB      00h
                org    24h
                RETF; JMP     INIT1_entry     ; offset 24h
                DB      00h
                org    28h
                RETF ; JMP     Extent_entry    ; offset 28h
                DB      00h
                org    2Ch
                RETF ; JMP     BootDisk_entry  ; offset 2Ch
                nop
                nop
                DB      00h
                DD      000000CBh,000000CBh,000000CBh,000000CBh
                DD      000000CBh,000000CBh,00000000h,00000000h
;------------------------------------------------
                org     50h
PCIR_signat     DB      "PCIR"
VendorID_Dev    DW      PCI_VENDOR 
DeviceID_Dev    DW      PCI_DEVICE
                DW      0000h           ;
Length_PCIR     DW      0018h           ; PCIR-structre byte length
; offset 5Ch
Revsion_Dev     DB      10h             ; revision=1  i82557 SZ758
ClassCode       DB      00h,00h,01h     ; PI,SUB,MAIN=Ethernet=00h,00h,02h
ROM_ImageSize   DW      ROM_IMAGE_SIZE  ; ROM image size for PC98image
                DW      0000h           
CodeType        DW      8000h           ; No next image=80, x86=00
                DW      0000h           ; reserved
                org     68h
CheckSumByteOrg DB      00h             ; 
CheckSumByte    DB      00h             ; 
PUSH_DS         DW      0D5D5h
                org     6Ch
PCI_called_SI   DW      5555h  ; 6Ch
PCI_called_DI   DW      9999h  ; 6Eh
PCI_called_EDX  DD      0DDDDDDDDh  ; 70h
PCI_called_ECX  DD      0CCCCCCCCh  ; 74h
PCI_called_EBX  DD      0BBBBBBBBh  ; 78h
PCI_addr_called DD      0AAAAAAAAh  ; 7Ch
                org     80h
INIT0_entry:
                pushf
                pushad
                push    gs
                push    fs
                push    es
                push    ds

                mov     cs:PUSH_DS,ds
                mov     cs:PCI_called_SI,si
                mov     cs:PCI_called_DI,di
                mov     cs:PCI_called_EDX,edx
                mov     cs:PCI_called_ECX,ecx
                mov     cs:PCI_called_EBX,ebx
                mov     cs:PCI_addr_called,eax
                call    ProgramStartPoint       ; near call  cs=8000h
                pop     ds
                pop     es
                pop     fs
                pop     gs
                popad
                popf
                retf
org (100h-8)    
                DD      0
org (100h-4)      
                DD      0
org     100h
ProgramStartPoint:

code    ends
        end     PCI_ROM_boot_program


