SECT_COUNT      equ     [2050h]
HEAD_COUNT      equ     [2052h]
CYLN_COUNT      equ     [2054h]
SECT_HEAD_COUNT equ     [2056h]
HS_VALUE        equ     [2058h]


Xa13W_patch     PROC    near
                cld
; Func_A
                mov     si,offset CodePtnA1
                mov     cx,offset CodePtnA1_end
                call    scan_pattern
                jc      BIOS_not_Xa13W
                mov     di,bx
                mov     si,offset PatPtnA1
           rep  movsb

                mov     si,offset CodePtnA2
                mov     cx,offset CodePtnA2_end
                call    scan_pattern
                jc      BIOS_not_Xa13W
                mov     di,bx
                mov     si,offset PatPtnA2
           rep  movsb

; Func_B
                mov     si,offset CodePtnB_Xa
                mov     cx,offset CodePtnB_Xa_end
                call    scan_pattern
                jc      BIOS_not_Xa13W
                mov     di,bx
                mov     si,offset PatPtnB_Xa
           rep  movsb

; Func_S
                mov     si,offset CodePtnS_Xa
                mov     cx,offset CodePtnS_Xa_end
                call    scan_pattern
                jc      BIOS_not_Xa13W
                mov     di,bx
                mov     si,offset PatPtnS
           rep  movsb

; Func_DA (sub)
                mov     si,offset space_nec
                mov     cx,offset space_nec_end
                call    scan_pattern
                jnc     @f
                mov     si,offset space44
                mov     cx,offset space44_end
                call    scan_pattern
                jc      BIOS_not_Xa13W
        @@: 
                mov     di,bx
                mov     cx,( offset FUNC_DA_part_end  - offset FUNC_DA_part)
                mov     si,offset FUNC_DA_part
           rep  movsb
                mov     si,offset call_st_DA
                mov     ds:[si],bx
; Func_DA (main)
                mov     si,offset CodePtnDA_Xa
                mov     cx,offset CodePtnDA_Xa_end
                call    scan_pattern
                jc      BIOS_not_Xa13W
                mov     di,bx
                mov     si,offset PatPtnDA_Xa
           rep  movsb

; Func_w (sub)
                mov     si,offset space_conner
                mov     cx,offset space_conner_end
                call    scan_pattern
                jnc     @f
                mov     si,offset space44
                mov     cx,offset space44_end
                call    scan_pattern
                jc      BIOS_not_Xa13W
        @@:
                mov     cx,( offset Func_W_part_end - offset Func_W_part)
                mov     si,offset Func_W_part
                mov     di,bx
           rep  movsb
                mov     si,offset call_st_W
                mov     ds:[si],bx

; Func_w (main)
                mov     si,offset CodePtnW_Xa
                mov     cx,offset CodePtnW_Xa_end
                call    scan_pattern
                jc      BIOS_not_Xa13W
                mov     di,bx
                mov     si,offset PatPtnW_Xa
           rep  movsb   

                clc
                ret
BIOS_not_Xa13W:
                stc
                ret
Xa13W_patch     ENDP

;===========================================================
CodePtnA1       label   byte
                mov     byte ptr es:[2000h],07h ; 07=HEAD count -1
                mov     byte ptr es:[2001h],00h
                mov     byte ptr es:[200Ah],11h ; 11h=HEAD*SECT 
CodePtnA1_end   label   byte

CodePtnA2       label   byte
                or      byte ptr es:[2004h],07
CodePtnA2_end   label   byte

PatPtnA1        label   byte
                mov     word ptr es:[2000h],0007h
                mov     ax,es:SECT_HEAD_COUNT   
                mov     byte ptr es:[200Ah],al
                dec     ah
                nop
                nop
PatPtnA1_end    label   byte

PatPtnA2       label   byte
                or      byte ptr es:[2004h],ah
                nop
PatPtnA2_end   label   byte

;------------------------------------------------------
CodePtnB_Xa     label   byte
                mov     ah,0Fh
                test    byte ptr [bp+01h],80h
                jz      OFFSET_03FE_Xa
                mov     word ptr [bp+02h],0200h
                mov     byte ptr [bp+06h],11h
                mov     byte ptr [bp+07h],08h
                mov     dx,es:[bx]
                mov     [bp+04h],dx
OFFSET_03FE_Xa: ret
CodePtnB_Xa_end label   byte

PatPtnB_Xa      label   byte            ; size OK
                mov     ah,0Fh
                test    byte ptr [bp+01h],80h
                jz      OFFSET_03FE_P
                mov     word ptr [bp+02h],0200h
                mov     dx,es:SECT_HEAD_COUNT
                mov     [bp+06h],dx
                mov     dx,es:[bx]
                mov     [bp+04h],dx
OFFSET_03FE_P:  ret
PatPtnB_Xa_end  label   byte

;-----------------------------------------------------------
CodePtnDA_Xa    label   byte            ; 072B_Xa
                mov     dx,[bp+06h]
                mov     ax,[bp+04h]
                test    byte ptr es:[207Bh],80h
                jz      OFFSET_IF_LBA
                push    cx
                mov     ax,0088h
                mul     word ptr [bp+04h]  ; cyl
                push    ax
                mov     ax,0011h
                mul     byte ptr [bp+07h]
                mov     cx,ax
                pop     ax
                clc
                add     ax,cx
                adc     dx,+00h
                add     al,[bp+06h]
                adc     ah,00h
                adc     dx,+00h
                pop     cx
OFFSET_IF_LBA:  
                push    cx
                mov     cx,0088h
                div     cx
                mov     es:[2002h],ax
                mov     cx,0011h
                mov     ax,dx
                xor     dx,dx
                div     cx
                and     byte ptr es:[2004h],0F0h
                or      es:[2004h],al
                inc     dl
                mov     es:[2005h],dl
                pop     cx
                mov     es:[200Ah],cl
                ret     
CodePtnDA_Xa_end label   byte

PatPtnDA_Xa     label   byte 
                mov     dx,[bp+06h]
                mov     ax,[bp+04h]
                test    byte ptr es:[207Bh],80h
                jz      OFFSET_IF_LBA_P
                push    cx
                mov     ax,es:HS_VALUE
                mul     word ptr [bp+04h]  ; cyl
                push    ax
                mov     ax,es:SECT_COUNT
                mul     byte ptr [bp+07h]
                mov     cx,ax
                pop     ax
                clc
                add     ax,cx
                adc     dx,+00h
                add     al,[bp+06h]
                adc     ah,00h
                adc     dx,+00h
                pop     cx
OFFSET_IF_LBA_P:
                push    cx
                mov     cx,es:HS_VALUE
                div     cx

                DB      9Ah
call_st_DA      label   word
                DW      3333h
                DW      0D800h
                xor     dx,dx
                div     cx
                and     byte ptr es:[2004h],0F0h
                or      es:[2004h],al
                inc     dl
                mov     es:[2005h],dl
                pop     cx
                mov     es:[200Ah],cl
                ret     
                DW      0,0,0
PatPtnDA_Xa_end label   byte
;-------------------------------
FUNC_DA_part    label   byte
                mov     es:[2002h],ax
                mov     cx,es:SECT_COUNT
                mov     ax,dx
                RETF
FUNC_DA_part_end        label   byte

;-----------------------------------------------------------
CodePtnW_Xa     label   byte    ; 
                push    cx
                mov     bx,2100h        ; bx=2100
                xor     cx,cx
                mov     ch,[bp+00h]     ; DrvN 0,1,2,3
                mov     cl,05h          ; 
                shl     ch,cl           ; ch=ch*20h , 5bit shift left
                xor     cl,cl           ; cl=0
                xchg    ch,cl           ; cx=00,20,40,60h
                add     bx,cx           ; bx=2100,2120,2140,2160h
                pop     cx
                ret     
CodePtnW_Xa_end label   byte

PatPtnW_Xa      label   byte
                push    ax
                mov     bl,[bp+00h]     ; bl=0,1,2,3
                shl     bl,5            ; bl=00,20,40,60h
                mov     bh,21h          ; bh=21h
                mov     al,es:[bx+07h]  ; 2107,2127,2147,2167h
                DB      9Ah                     ; call far
call_st_W       label   word
                DW      2222h
                DW      0D800h
                pop     ax
                ret
                nop
                nop
PatPtnW_Xa_end  label   byte

Func_W_part     label   byte
                mov     al,es:[bx+07h]  ; BX=2100+ drvn*20h
                mov     es:SECT_COUNT,al ; sect
                mov     ah,es:[bx+0Ah]  ;
                mov     es:HEAD_COUNT,ah ; head
                mov     es:SECT_HEAD_COUNT,ax
                mov     ax,es:[bx+08h]  ; H*S
                mov     es:HS_VALUE,ax
                mov     ax,es:[bx]
                mov     es:CYLN_COUNT,ax ; 
                RETF
                DB      0
Func_W_part_end label   byte

;-----------------------------------------------------------

CodePtnS_Xa     label   byte
                mov     ax,es:[di+0Ch]
                xchg    ah,al           
                mov     cx,es:[di+06h]
                xchg    ch,cl
                mul     cx              ;  AX= H*S
                mov     cx,es:[di+02h]  ;  CX= cyln
                xchg    ch,cl
                mul     cx              ;  DX:AX= (H*S)*cyln
                mov     cx,0088h ; These instructions should be removed.
                div     cx       ; These instructions should be removed.
                mov     es:[bx],ax      ; ES,BX,AX should be preserved
CodePtnS_Xa_end label   byte

PatPtnS         label   byte
;;;                mov     ax,es:[di+0Ch]  ;  AX=sect N    = 10h
;;;                xchg    ah,al
;;;                mov     cx,es:[di+06h]  ;  CX=head N    = 3Fh  
;;;                xchg    ch,cl
;;;                mul     cx              ;  AX= H*S      = CH =FF CL =3F 
;;;                mov     cx,es:[di+02h]  ;  CX= cyln
;;;                xchg    ch,cl
;;;                mul     cx              ;  DX:AX= (H*S)*cyln
                DB      9Ah     ; call far
                DW      offset NEWCODE_SET_CHS
;SegThisBoard   label   word            ; cx= DX:AX div 
                DW      MEMseg
                mov     es:[bx],ax
                nop
                nop
                DB      28 dup (90h)
PatPtnS_end     label   byte

;-----------------------------------------------------------
